#include <httplib.h>
#include <nlohmann/json.hpp>
#include <base64.hpp>
#include <utils.hpp>
#include <iostream>
#include <string>

using json = nlohmann::json;
using namespace xhai;


int main(int argc, char* argv[])
{
    if(argc != 2) {
       std::cout << "usage: demo ./img.jpg" << std::endl;
       return -1;	
    }
    httplib::Client cli("api.xinhuokj.com", 28901);

    std::string image_data;
    get_file_content(argv[1], &image_data);

    json data;
    data["token"] = "b4de50360------cddddcopkjytrks";//您的token，可在http://www.xinhuokj.com/user获取
    data["image"] = base64_encode(image_data.c_str(), image_data.size());
    data["type"] = "0";
    std::string data_str =  data.dump();

    auto res = cli.Post("/ocr", data_str.c_str(), "application/json");
    if (res && res->status == 200) {

		auto ret_data = json::parse(res->body);
			std::cout << ret_data.dump() << std::endl;

		int num = ret_data["words_result_num"];
		std::cout << "word_num: " << num << std::endl;
		auto words_result = ret_data["words_result"];
		for(auto it: words_result) {
			std::cout << it["words"] << std::endl;	
		}

    }
}
